#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
#define CCHMAXPATH 260		/* pX/t@C̍ő咷 */

#define N_SG		18		/* 1 Sector  Segment  */
#define N_DATA		128		/* 1 Segment ̃f[^(byte) */
#define N_SAMPLE	224		/* 1 Segment ̃Tv */


/* *.wav file header */
typedef struct {
	char	acID[4];
	ULONG	cbSize;
	char	acWavID[4];
	char	acFmt[4];
	ULONG	qq1;
	USHORT	usFormatTag;
	USHORT	usCannels;
	ULONG	ulSamplePerSec;
	ULONG	ulAvgBytePerSec;
	USHORT	usBlockAlign;
	USHORT	qq2;
	char	acData[4];
	ULONG	cbSizeOfData;
}	RIFFWAVHEADER;


/* OubÑf[^ۑp */
typedef struct {
	double	dPrev1;	/* 1O */
	double	dPrev2;	/* 2O */
}	ADPCM_PREVDATA;


/* wav t@C̃wb_[쐬
*/
void
makeWavHeader( RIFFWAVHEADER *prwd, long lSample )
{
	strncpy( prwd->acID, "RIFF", 4 );
	strncpy( prwd->acWavID, "WAVE", 4 );
	strncpy( prwd->acFmt, "fmt ", 4 );
	prwd->qq1 = 0x10;
	prwd->usFormatTag = 1;
	prwd->usCannels = 1;
	prwd->ulSamplePerSec = lSample;
	prwd->ulAvgBytePerSec = lSample*2;
	prwd->usBlockAlign = 2;
	prwd->qq2 = 16;
	strncpy( prwd->acData, "data", 4 );
}


/* 1 Segment ADPCM dataϊ
*/
void
adpcm2pcm( UCHAR *pucI, short *psO, ADPCM_PREVDATA *papd )
{
	long	i, j;
	long	r, f; /* range, filter */
	double	x, p1, p2;
	long	x2;
	const double	k0[4] = { 0.0, 0.9375, 1.796875, 1.53125 };
	const double	k1[4] = { 0.0, 0.0, -0.8125, -0.859375 };

	p1 = papd->dPrev1, p2 = papd->dPrev2;

	for ( i = 0; i < 4; i++ ) {
		r = 1 << (12 - ( pucI[i*2+4] & 15 ));
		f = pucI[i*2+4]>>4;
		for ( j = 0; j < 28; j++ ) {
			x = (double)( pucI[16+i+j*4] & 15 );
			if ( x >= 8 )	x -= 16;
			x *= r;
			x += p1*k0[f] + p2*k1[f];
			x2 = x * 0.9;
			if ( x2 < -32768 )	x2 = -32768;
			if ( x2 >= 32767 )	x2 = 32767;
			psO[i*56+j] = (short)x2;
			p2 = p1, p1 = x;
		}
		r = 1 << (12 - ( pucI[i*2+5] & 15 ));
		f = pucI[i*2+5]>>4;
		for ( j = 0; j < 28; j++ ) {
			x = (double)( pucI[16+i+j*4] >> 4 );
			if ( x >= 8 )	x -= 16;
			x *= r;
			x += p1*k0[f] + p2*k1[f];
			x2 = x* 0.95;
			if ( x2 < -32768 )	x2 = -32768;
			if ( x2 >= 32767 )	x2 = 32767;
			psO[i*56+28+j] = (short)x2;
			p2 = p1, p1 = x;
		}
	}
	papd->dPrev1 = p1, papd->dPrev2 = p2;
}


void
getOptions( int argc, char *argv[], long *plRawdata,
	long *plFrom, long *plTo, long *plRate )
{
	UCHAR	*puc;
	long	i;

	puc = strrchr( argv[1], '.' );
	if ( puc == NULL || stricmp( puc, ".raw" ) != 0 ) {
		*plRawdata = 0;
		printf( "normal ADPCM data.\n" );
	}
	else {
		*plRawdata = 1;
		printf( "CD-XA format 2 raw data.\n" );
	}

	*plFrom = 0, *plTo = -1, *plRate = 37800;
	for ( i = 2; i < argc; i++ ) {
		if ( *argv[i] == '-' || *argv[i] == '/' ) {
			switch( *(argv[i]+1) ) {
			case 's':
			case 'S':
				if ( *(argv[i]+2) != '\0' ) {
					*plFrom = atol( argv[i]+2 );
				}
				else {
					if ( ++i >= argc )	break;
					*plFrom = atol( argv[i] );
				}
				if ( *plFrom < 0 )	*plFrom = 0;
				printf( "start segment: %ld\n", *plFrom );
				break;
			case 'e':
			case 'E':
				if ( *(argv[i]+2) != '\0' ) {
					*plTo = atol( argv[i]+2 );
				}
				else {
					if ( ++i >= argc )	break;
					*plTo = atol( argv[i] );
				}
				printf( "end segment: %ld\n", *plTo );
				break;
			case 'r':
			case 'R':
				if ( *(argv[i]+2) != '\0' ) {
					*plRate = atol( argv[i]+2 );
				}
				else {
					if ( ++i >= argc )	break;
					*plRate = atol( argv[i] );
				}
				printf( "sampling rate: %ld\n", *plRate );
				break;
			}
		}
	}
}


main( int argc, char *argv[] )
{
	FILE	*fpR, *fpW;
	char	szFNW[CCHMAXPATH], szFNR[CCHMAXPATH];
	UCHAR	aucIBuf[N_DATA];
	short	asOBuf[N_SAMPLE];
	RIFFWAVHEADER	rwd;
	ADPCM_PREVDATA	apd;
	long	lcData;
	long	i;
	long	lTo, lFrom, lRate;
	long	lfRawdata, lfFirst;


	if ( argc < 2 )	{
		printf( "\ncdxa2wav.exe - Convert CD-XA ADPCM data to PCM data.\n" );
		printf( "usage: dexa2wav (source filename) [-s n] [-e n] [-r n]\n" );
		printf( "\t-s: n = start segment (1 segment = 128bytes).\n" );
		printf( "\t-e: n = end segment\n" );
		printf( "\t-r: n = sampling rate (default: 37800)\n\n" );
		exit( 1 );
	}
	strcpy( szFNR, argv[1] );

	if ( ( fpR = fopen( szFNR, "rb" ) ) == NULL ) {
		printf( "Can't open source file.\n\n" );
		exit( 2 );
	}
	if ( ( fpW = fopen( "out.wav", "wb" ) ) == NULL ) {
		printf( "Can't open output file.\n\n" );
		fclose( fpR );
		exit( 3 );
	}

	getOptions( argc, argv, &lfRawdata, &lFrom, &lTo, &lRate );

	makeWavHeader( &rwd, lRate );
	fwrite( (UCHAR*)&rwd, 1, sizeof( RIFFWAVHEADER ), fpW );

	if ( lFrom != 0 ) {
		i = lFrom * N_DATA;
		if ( lfRawdata ) {
			i += (lFrom / N_SG + 1)*24; 		/* wb_skip */
			i += ((lFrom - N_SG)/N_SG + 1)*24;	/* ]EDCskip */
		}
		fseek( fpR, i, SEEK_SET );
	}

	lfFirst = 0;
	if ( lFrom % N_SG == 0 )	lfFirst = 1;
	lcData = 0;
	apd.dPrev1 = apd.dPrev2 = 0.0;

	for ( i = lFrom; lTo == -1 || i <= lTo; i++ ) {
		if ( lfRawdata != 0 && i%N_SG == 0 ) {
			if ( lfFirst ) {
				fseek( fpR, 24, SEEK_CUR );
				lfFirst = 0;
			}
			else fseek( fpR, 24 + 24, SEEK_CUR );
		}

		if ( fread( aucIBuf, 1, N_DATA, fpR ) < N_DATA )	break;
		adpcm2pcm( aucIBuf, asOBuf, &apd );
		if ( fwrite( asOBuf, 1, sizeof(asOBuf), fpW ) < sizeof(asOBuf) ) {
			printf( "Writing error!" );
			break;
		}
		lcData += sizeof(asOBuf);
	}

	rwd.cbSizeOfData = lcData;
	rwd.cbSize = lcData + sizeof( RIFFWAVHEADER );

	fseek( fpW, 0, SEEK_SET );
	fwrite( (UCHAR*)&rwd, 1, sizeof( RIFFWAVHEADER ), fpW );

	fclose( fpW );
	fclose( fpR );
}



